using Random
using UUIDs

rng = Random.MersenneTwister(0);

abstract type Node end

struct DataTaskNode <: Node
   task::AbstractDataTask
   id::Base.UUID  # need a unique identifier unique to every *constructed* node
end

struct ComputeTaskNode <: Node
   task::AbstractComputeTask
   id::Base.UUID  # need a unique identifier unique to every *constructed* node
end

function DataTaskNode(t::AbstractDataTask)
   return DataTaskNode(t, UUIDs.uuid1(rng))
end

function ComputeTaskNode(t::AbstractComputeTask)
   return ComputeTaskNode(t, UUIDs.uuid1(rng))
end

struct Edge
   edge::Union{Tuple{Ref{DataTaskNode}, Ref{ComputeTaskNode}}, Tuple{Ref{ComputeTaskNode}, Ref{DataTaskNode}}}
end
